
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "dokan.h"
#include "databasewrapper.h"
#include "directorylister.h"
#include "debug.h"
#include "stringhelper.h"

static WCHAR RootDirectory[MAX_PATH] = L"C:";

/*static void GetFilePath(PWCHAR	filePath, LPCWSTR FileName) {
	RtlZeroMemory(filePath, MAX_PATH);
	wcsncpy(filePath, RootDirectory, wcslen(RootDirectory));
	wcsncat(filePath, FileName, wcslen(FileName));
}*/

#define MetaFSCheckFlag(val, flag) if(val&flag) fprintf(stderr, "\t" #flag "\n")

static int __stdcall MetaFSCreateFile(LPCWSTR FileName, DWORD AccessMode, DWORD ShareMode, DWORD CreationDisposition,
	                                   DWORD FlagsAndAttributes, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR filePath[MAX_PATH];
	HANDLE handle;

   return 0;

/*   GetFilePath(filePath, FileName);

	fwprintf(stderr, L"CreateFile : %s\n", filePath);
	
	if (CreationDisposition == CREATE_NEW)
		fprintf(stderr, "\tCREATE_NEW\n");
	if (CreationDisposition == OPEN_ALWAYS)
		fprintf(stderr, "\tOPEN_ALWAYS\n");
	if (CreationDisposition == CREATE_ALWAYS)
		fprintf(stderr, "\tCREATE_ALWAYS\n");
	if (CreationDisposition == OPEN_EXISTING)
		fprintf(stderr, "\tOPEN_EXISTING\n");
	if (CreationDisposition == TRUNCATE_EXISTING)
		fprintf(stderr, "\tTRUNCATE_EXISTING\n");

	
//	if (ShareMode == 0 && AccessMode & FILE_WRITE_DATA)
//		ShareMode = FILE_SHARE_WRITE;
//	else if (ShareMode == 0)
//		ShareMode = FILE_SHARE_READ;
	

	fprintf(stderr, "\tShareMode = 0x%x\n", ShareMode);

	MetaFSCheckFlag(ShareMode, FILE_SHARE_READ);
	MetaFSCheckFlag(ShareMode, FILE_SHARE_WRITE);
	MetaFSCheckFlag(ShareMode, FILE_SHARE_DELETE);

	fprintf(stderr, "\tAccessMode = 0x%x\n", AccessMode);

	MetaFSCheckFlag(AccessMode, GENERIC_READ);
	MetaFSCheckFlag(AccessMode, GENERIC_WRITE);
	MetaFSCheckFlag(AccessMode, GENERIC_EXECUTE);
	
	MetaFSCheckFlag(AccessMode, DELETE);
	MetaFSCheckFlag(AccessMode, FILE_READ_DATA);
	MetaFSCheckFlag(AccessMode, FILE_READ_ATTRIBUTES);
	MetaFSCheckFlag(AccessMode, FILE_READ_EA);
	MetaFSCheckFlag(AccessMode, READ_CONTROL);
	MetaFSCheckFlag(AccessMode, FILE_WRITE_DATA);
	MetaFSCheckFlag(AccessMode, FILE_WRITE_ATTRIBUTES);
	MetaFSCheckFlag(AccessMode, FILE_WRITE_EA);
	MetaFSCheckFlag(AccessMode, FILE_APPEND_DATA);
	MetaFSCheckFlag(AccessMode, WRITE_DAC);
	MetaFSCheckFlag(AccessMode, WRITE_OWNER);
	MetaFSCheckFlag(AccessMode, SYNCHRONIZE);
	MetaFSCheckFlag(AccessMode, FILE_EXECUTE);
	MetaFSCheckFlag(AccessMode, STANDARD_RIGHTS_READ);
	MetaFSCheckFlag(AccessMode, STANDARD_RIGHTS_WRITE);
	MetaFSCheckFlag(AccessMode, STANDARD_RIGHTS_EXECUTE);


	// when filePath is a directory, flags is changed to the file be opened
	if (GetFileAttributes(filePath) & FILE_ATTRIBUTE_DIRECTORY) {
		FlagsAndAttributes |= FILE_FLAG_BACKUP_SEMANTICS;
		//AccessMode = 0;
	}

	fprintf(stderr, "\tFlagsAndAttributes = 0x%x\n", FlagsAndAttributes);

	MetaFSCheckFlag(FlagsAndAttributes, FILE_ATTRIBUTE_ARCHIVE);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_ATTRIBUTE_ENCRYPTED);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_ATTRIBUTE_HIDDEN);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_ATTRIBUTE_NORMAL);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_ATTRIBUTE_NOT_CONTENT_INDEXED);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_ATTRIBUTE_OFFLINE);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_ATTRIBUTE_READONLY);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_ATTRIBUTE_SYSTEM);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_ATTRIBUTE_TEMPORARY);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_FLAG_WRITE_THROUGH);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_FLAG_OVERLAPPED);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_FLAG_NO_BUFFERING);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_FLAG_RANDOM_ACCESS);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_FLAG_SEQUENTIAL_SCAN);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_FLAG_DELETE_ON_CLOSE);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_FLAG_BACKUP_SEMANTICS);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_FLAG_POSIX_SEMANTICS);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_FLAG_OPEN_REPARSE_POINT);
	MetaFSCheckFlag(FlagsAndAttributes, FILE_FLAG_OPEN_NO_RECALL);
	MetaFSCheckFlag(FlagsAndAttributes, SECURITY_ANONYMOUS);
	MetaFSCheckFlag(FlagsAndAttributes, SECURITY_IDENTIFICATION);
	MetaFSCheckFlag(FlagsAndAttributes, SECURITY_IMPERSONATION);
	MetaFSCheckFlag(FlagsAndAttributes, SECURITY_DELEGATION);
	MetaFSCheckFlag(FlagsAndAttributes, SECURITY_CONTEXT_TRACKING);
	MetaFSCheckFlag(FlagsAndAttributes, SECURITY_EFFECTIVE_ONLY);
	MetaFSCheckFlag(FlagsAndAttributes, SECURITY_SQOS_PRESENT);

	handle = CreateFile( filePath,
		                  AccessMode,
		                  ShareMode,
		                  NULL, // security attribute
		                  CreationDisposition,
		                  FlagsAndAttributes,
		                  NULL);

	if (handle == INVALID_HANDLE_VALUE) {
		DWORD error = GetLastError();
		fprintf(stderr, "\terror code = %d\n\n", error);
		return error * -1; // error codes are negated value of Windows System Error codes
	}

	fprintf(stderr, "\n");

	// save the file handle in Context
   DokanFileInfo->Context = new FileContext();
   DokanFileInfo->Context->filehandle = (ULONG64)handle;
	return 0;*/
}


static int __stdcall MetaFSCreateDirectory(LPCWSTR FileName, PDOKAN_FILE_INFO DokanFileInfo) {
   /*
   WCHAR filePath[MAX_PATH];
	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"CreateDirectory : %s\n", filePath);
	CreateDirectory(filePath, NULL);
   */
	return 0;
};


static int __stdcall MetaFSOpenDirectory(LPCWSTR FileName, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR filePath[MAX_PATH];
	HANDLE handle;
   
/*	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"OpenDirectory : %s\n", filePath);

	handle = CreateFile(
		filePath,
		0,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		FILE_FLAG_BACKUP_SEMANTICS,
		NULL);

	if (handle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "\terror code = %d\n\n", GetLastError());
		return -1;
	}
	fprintf(stderr, "\n");
   DokanFileInfo->Context = new FileContext();
	DokanFileInfo->Context->filehandle = (ULONG64)handle;*/
	return 0;
}


static int __stdcall MetaFSCloseFile(LPCWSTR FileName, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR filePath[MAX_PATH];

/*	GetFilePath(filePath, FileName);

	if (DokanFileInfo->Context) {
		fwprintf(stderr, L"CloseFile: %s\n", filePath);
		fprintf(stderr, "\terror : not cleanuped file\n\n");
		CloseHandle((HANDLE)DokanFileInfo->Context->filehandle);
      delete DokanFileInfo->Context;
		DokanFileInfo->Context = 0;
	} else {
		fwprintf(stderr, L"CloseFile(already closed): %s\n\n", filePath);
		return 0;
	}*/
	return 0;
}


static int __stdcall MetaFSCleanup(LPCWSTR FileName, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR filePath[MAX_PATH];

/*	GetFilePath(filePath, FileName);

	if (DokanFileInfo->Context) {
		fwprintf(stderr, L"Cleanup: %s\n\n", filePath);
		CloseHandle((HANDLE)DokanFileInfo->Context->filehandle);
      delete DokanFileInfo->Context;
		DokanFileInfo->Context = 0;
	} else {
		fwprintf(stderr, L"Cleanup: %s\n\tinvalid handle\n\n", filePath);
		return -1;
	}*/
	return 0;
}


static int __stdcall MetaFSReadFile(LPCWSTR FileName, LPVOID Buffer, DWORD BufferLength,
	                                 LPDWORD ReadLength, LONGLONG Offset, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR	filePath[MAX_PATH];

/*	HANDLE	handle = (HANDLE)DokanFileInfo->Context->filehandle;
	ULONG	offset = (ULONG)Offset;
	BOOL	opened = FALSE;

	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"ReadFile : %s\n", filePath);

	if (!handle || handle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "\tinvalid handle, cleanuped?\n");
		handle = CreateFile(
			filePath,
			GENERIC_READ,
			FILE_SHARE_READ,
			NULL,
			OPEN_EXISTING,
			0,
			NULL);
		if (handle == INVALID_HANDLE_VALUE) {
			fprintf(stderr, "\tCreateFile error : %d\n\n", GetLastError());
			return -1;
		}
		opened = TRUE;
	}
	
	if (SetFilePointer(handle, offset, NULL, FILE_BEGIN) == 0xFFFFFFFF) {
		fprintf(stderr, "\tseek error, offset = %d\n\n", offset);
		if (opened)
			CloseHandle(handle);
		return -1;
	}

		
	if (!ReadFile(handle, Buffer, BufferLength, ReadLength,NULL)) {
		fprintf(stderr, "\tread error = %u, buffer length = %d, read length = %d\n\n",
			GetLastError(), BufferLength, *ReadLength);
		if (opened)
			CloseHandle(handle);
		return -1;

	} else {
		fprintf(stderr, "\tread %d, offset %d\n\n", *ReadLength, offset);
	}

	if (opened)
		CloseHandle(handle);
*/
	return 0;
}


static int __stdcall MetaFSWriteFile(LPCWSTR FileName, LPCVOID Buffer, DWORD NumberOfBytesToWrite,
            	                      LPDWORD NumberOfBytesWritten, LONGLONG Offset, PDOKAN_FILE_INFO DokanFileInfo) {
/*	WCHAR	filePath[MAX_PATH];
	HANDLE	handle = (HANDLE)DokanFileInfo->Context->filehandle;
	ULONG	offset = (ULONG)Offset;
	BOOL	opened = FALSE;

	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"WriteFile : %s, offset %I64d, length %d\n", filePath, Offset, NumberOfBytesToWrite);

	// reopen the file
	if (!handle || handle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "\tinvalid handle, cleanuped?\n");
		handle = CreateFile(
			filePath,
			GENERIC_WRITE,
			FILE_SHARE_WRITE,
			NULL,
			OPEN_EXISTING,
			0,
			NULL);
		if (handle == INVALID_HANDLE_VALUE) {
			fprintf(stderr, "\tCreateFile error : %d\n\n", GetLastError());
			return -1;
		}
		opened = TRUE;
		
		return -1;
	}

	if (SetFilePointer(handle, offset, NULL, FILE_BEGIN) == INVALID_SET_FILE_POINTER) {
		fprintf(stderr, "\tseek error, offset = %d, error = %d\n", offset, GetLastError());
		return -1;
	}

	if (!WriteFile(handle, Buffer, NumberOfBytesToWrite, NumberOfBytesWritten, NULL)) {
		fprintf(stderr, "\twrite error = %u, buffer length = %d, write length = %d\n",
			GetLastError(), NumberOfBytesToWrite, *NumberOfBytesWritten);
		return -1;
	} else {
		fprintf(stderr, "\twrite %d, offset %d\n\n", *NumberOfBytesWritten, offset);
	}

	// close the file when it is reopened
	if (opened)
		CloseHandle(handle);
*/
	return 0;
}


static int __stdcall MetaFSFlushFileBuffers( LPCWSTR FileName, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR	filePath[MAX_PATH];
/*	HANDLE	handle = (HANDLE)DokanFileInfo->Context->filehandle;

	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"FlushFileBuffers : %s\n", filePath);

	if (!handle || handle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "\tinvalid handle\n\n");
		return 0;
	}

	if (FlushFileBuffers(handle)) {
		return 0;
	} else {
		fprintf(stderr, "\tflush error code = %d\n", GetLastError());
		return -1;
	}
*/
   return 0;
}


static int __stdcall MetaFSGetFileInformation(LPCWSTR FileName, LPBY_HANDLE_FILE_INFORMATION HandleFileInformation,
	                                           PDOKAN_FILE_INFO DokanFileInfo) {
   fwprintf(stderr, L"GetFileInformation(%s)\n", FileName);

	WCHAR	filePath[MAX_PATH];
/*	HANDLE	handle = (HANDLE)DokanFileInfo->Context->filehandle;

	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"GetFileInfo : %s\n", filePath);

	if (!handle || handle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "\tinvalid handle\n\n");
		return -1;
	}

	if (!GetFileInformationByHandle(handle,HandleFileInformation)) {
		fprintf(stderr, "\terror code = %d\n", GetLastError());

		// FileName is a root directory
		// in this case, FindFirstFile can't get directory information
		if (wcslen(FileName) == 1) {
			HandleFileInformation->dwFileAttributes = GetFileAttributes(filePath);

		} else {
			WIN32_FIND_DATAW find;
			ZeroMemory(&find, sizeof(WIN32_FIND_DATAW));
			handle = FindFirstFile(filePath, &find);
			if (handle == INVALID_HANDLE_VALUE) {
				fprintf(stderr, "\tFindFirstFile error code = %d\n\n", GetLastError());
				return -1;
			}
			HandleFileInformation->dwFileAttributes = find.dwFileAttributes;
			HandleFileInformation->ftCreationTime = find.ftCreationTime;
			HandleFileInformation->ftLastAccessTime = find.ftLastAccessTime;
			HandleFileInformation->ftLastWriteTime = find.ftLastWriteTime;
			HandleFileInformation->nFileSizeHigh = find.nFileSizeHigh;
			HandleFileInformation->nFileSizeLow = find.nFileSizeLow;
			fprintf(stderr, "\tFindFiles OK\n");
			CloseHandle(handle);
		}
	}

	fprintf(stderr, "\n");
*/
   HandleFileInformation->dwFileAttributes = FILE_ATTRIBUTE_DIRECTORY | FILE_ATTRIBUTE_READONLY;
   return 0;
}

/*typedef struct _WIN32_FIND_DATA {
  DWORD dwFileAttributes;
  FILETIME ftCreationTime;
  FILETIME ftLastAccessTime;
  FILETIME ftLastWriteTime;
  DWORD nFileSizeHigh;
  DWORD nFileSizeLow;
  DWORD dwReserved0;
  DWORD dwReserved1;
  TCHAR cFileName[MAX_PATH];
  TCHAR cAlternateFileName[14];
} WIN32_FIND_DATA, 
 *PWIN32_FIND_DATA, 
 *LPWIN32_FIND_DATA;


 BOOL WINAPI GetFileAttributesEx(
  __in   LPCTSTR lpFileName,
  __in   GET_FILEEX_INFO_LEVELS fInfoLevelId,
  __out  LPVOID lpFileInformation );
The lpFileInformation parameter is a WIN32_FILE_ATTRIBUTE_DATA structure.


typedef struct _WIN32_FILE_ATTRIBUTE_DATA {
  DWORD dwFileAttributes;
  FILETIME ftCreationTime;
  FILETIME ftLastAccessTime;
  FILETIME ftLastWriteTime;
  DWORD nFileSizeHigh;
  DWORD nFileSizeLow;
} WIN32_FILE_ATTRIBUTE_DATA, 
 *LPWIN32_FILE_ATTRIBUTE_DATA;

*/

static int __stdcall MetaFSFindFiles(LPCWSTR FileName, PFillFindData FillFindData, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR				   filePath[MAX_PATH];
	HANDLE				hFind;
	WIN32_FIND_DATAW	findData;
	DWORD				   error;
	PWCHAR				yenStar = L"\\*";
	int count = 0;
   
   fwprintf(stderr, L"->  MetaFSFindFiles(%s)\n", FileName);

   TagDirectoryLister lister(toNarrowString(FileName, -1));

   std::string file;
   file = lister.getNextFile();
   while(file.length() != 0) {

//      fprintf(stderr, "   -> %s\n", file.c_str());

      std::wstring unicodeFilename = toWideString(file.c_str(), -1);
      wcscpy(findData.cFileName, unicodeFilename.c_str());
      findData.dwFileAttributes = FILE_ATTRIBUTE_READONLY;           //FILE_ATTRIBUTE_DIRECTORY
      findData.nFileSizeHigh = 0;
      findData.nFileSizeLow = 0;

      FillFindData(&findData, DokanFileInfo);
      file = lister.getNextFile();
   }

   std::string tag;
   tag = lister.getFirstTagInCurDirectory();
   while(tag.length() != 0) {
      std::wstring unicodeTag = toWideString(tag.c_str(), -1);
      wcscpy(findData.cFileName, unicodeTag.c_str());
      findData.dwFileAttributes = FILE_ATTRIBUTE_READONLY | FILE_ATTRIBUTE_DIRECTORY;
      FillFindData(&findData, DokanFileInfo);

      tag = lister.getNextTagInCurDirectory();
   }

/* GetFilePath(filePath, FileName);

	wcscat(filePath, yenStar);
	fwprintf(stderr, L"FindFiles :%s\n", filePath);

	hFind = FindFirstFile(filePath, &findData);

	if (hFind == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "\tinvalid file handle. Error is %u\n\n", GetLastError());
		return -1;
	}

	FillFindData(&findData, DokanFileInfo);
	count++;

	while (FindNextFile(hFind, &findData) != 0) {
 		FillFindData(&findData, DokanFileInfo);
		count++;
	}
	
	error = GetLastError();
	FindClose(hFind);

	if (error != ERROR_NO_MORE_FILES) {
		fprintf(stderr, "\tFindNextFile error. Error is %u\n\n", error);
		return -1;
	}

	fwprintf(stderr, L"\tFindFiles return %d entries in %s\n\n", count, filePath);
*/
	return 0;
}


static int __stdcall MetaFSDeleteFile(LPCWSTR FileName, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR	filePath[MAX_PATH];
/*	HANDLE	handle = (HANDLE)DokanFileInfo->Context->filehandle;

	GetFilePath(filePath, FileName);

	// file handle must be closed before deleted
	if (handle)
		CloseHandle(handle);

   delete DokanFileInfo->Context;
	DokanFileInfo->Context = 0;

	fwprintf(stderr, L"DeleteFile %s\n", filePath);

	if (DeleteFile(filePath) == 0) {
		fwprintf(stderr, L"\terror code %d\n\n", GetLastError());
		return -1;
	}
	
	fwprintf(stderr, L"\tsuccess\n\n");*/
	return 0;
}


static int __stdcall MetaFSDeleteDirectory(LPCWSTR FileName, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR	filePath[MAX_PATH];
/*	HANDLE	handle = (HANDLE)DokanFileInfo->Context->filehandle;

	GetFilePath(filePath, FileName);

	// file handle must be closed before deleted
	if (handle)
		CloseHandle(handle);

   delete DokanFileInfo->Context;
	DokanFileInfo->Context = 0;*/

/*	fwprintf(stderr, L"DeleteDirectory %s\n", filePath);

	if (!RemoveDirectory(filePath)) {
		fprintf(stderr, "\terror code = %d\n", GetLastError());
		return -1;
	}
	fwprintf(stderr, L"\tsuccess\n\n");*/
	return 0;
}


static int __stdcall MetaFSMoveFile(LPCWSTR FileName, LPCWSTR NewFileName, BOOL ReplaceIfExisting, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR			filePath[MAX_PATH];
	WCHAR			newFilePath[MAX_PATH];
	BOOL			status = FALSE;

/*	GetFilePath(filePath, FileName);
	GetFilePath(newFilePath, NewFileName);

	fwprintf(stderr, L"MoveFile %s -> %s\n\n", filePath, newFilePath);

	if (DokanFileInfo->Context) {
		// should close? or rename at closing?
		CloseHandle((HANDLE)DokanFileInfo->Context->filehandle);
      delete DokanFileInfo->Context;
		DokanFileInfo->Context = 0;
	}
/*
	if (ReplaceIfExisting)
		status = MoveFileEx(filePath, newFilePath, MOVEFILE_REPLACE_EXISTING);
	else
		status = MoveFile(filePath, newFilePath);

	if (status == 0)
		fprintf(stderr, "\tMoveFile failed status = %d, code = %d\n", status, GetLastError());
*/
	return status == TRUE ? 0 : -1;
}


static int __stdcall MetaFSLockFile(LPCWSTR FileName, LONGLONG ByteOffset, LONGLONG Length, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR	filePath[MAX_PATH];
	HANDLE	handle;
	LARGE_INTEGER offset;
	LARGE_INTEGER length;

/*	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"LockFile %s\n", filePath);

	handle = (HANDLE)DokanFileInfo->Context->filehandle;
	if (!handle || handle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "\tinvalid handle\n\n");
		return -1;
	}

	length.QuadPart = Length;
	offset.QuadPart = ByteOffset;

	if (LockFile(handle, offset.HighPart, offset.LowPart, length.HighPart, length.LowPart)) {
		fprintf(stderr, "\tsuccess\n\n");
		return 0;
	} else {
		fprintf(stderr, "\tfail\n\n");
		return -1;
	}*/
   return 0;
}


static int __stdcall MetaFSSetEndOfFile(LPCWSTR FileName, LONGLONG ByteOffset, PDOKAN_FILE_INFO DokanFileInfo) {
	WCHAR			filePath[MAX_PATH];
	HANDLE			handle;
	LARGE_INTEGER	offset;

/*	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"SetEndOfFile %s, %I64d\n", filePath, ByteOffset);

	handle = (HANDLE)DokanFileInfo->Context->filehandle;
	if (!handle || handle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "\tinvalid handle\n\n");
		return -1;
	}

	offset.QuadPart = ByteOffset;
	if (!SetFilePointerEx(handle, offset, NULL, FILE_BEGIN)) {
		fprintf(stderr, "\tSetFilePointer error: %d, offset = %I64d\n\n", GetLastError(), ByteOffset);
		return -1;
	}

	if (!SetEndOfFile(handle)) {
		fprintf(stderr, "\tSetEndOfFile error: %d\n\n", GetLastError());
		return -1;
	}
*/
	return 0;
}


static int __stdcall MetaFSSetFileAttributes(LPCWSTR FileName, DWORD FileAttributes, PDOKAN_FILE_INFO DokanFileInfo) {
/*	WCHAR	filePath[MAX_PATH];
	
	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"SetFileAttributes %s\n", filePath);

	if (!SetFileAttributes(filePath, FileAttributes)) {
		fprintf(stderr, "\terror: %d\n\n", GetLastError());
		return -1;
	}

	fprintf(stderr, "\n");*/
	return 0;
}


static int __stdcall MetaFSSetFileTime(LPCWSTR FileName, CONST FILETIME* CreationTime,
      CONST FILETIME* LastAccessTime, CONST FILETIME* LastWriteTime, PDOKAN_FILE_INFO DokanFileInfo) {
/*
	WCHAR	filePath[MAX_PATH];
	HANDLE	handle;

	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"SetFileTime %s\n", filePath);

	handle = (HANDLE)DokanFileInfo->Context->filehandle;

	if (!handle || handle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "\tinvalid handle\n\n");
		return -1;
	}

	if (!SetFileTime(handle, CreationTime, LastAccessTime, LastWriteTime)) {
		fprintf(stderr, "\terror: %d\n\n", GetLastError());
		return -1;
	}

	fprintf(stderr, "\n");*/
	return 0;
}



static int __stdcall MetaFSUnlockFile(LPCWSTR FileName, LONGLONG ByteOffset, LONGLONG Length,
                                      PDOKAN_FILE_INFO	DokanFileInfo) {
	WCHAR	filePath[MAX_PATH];
	HANDLE	handle;
	LARGE_INTEGER	length;
	LARGE_INTEGER	offset;

/*	GetFilePath(filePath, FileName);

	fwprintf(stderr, L"UnlockFile %s\n", filePath);

	handle = (HANDLE)DokanFileInfo->Context->filehandle;
	if (!handle || handle == INVALID_HANDLE_VALUE) {
		fprintf(stderr, "\tinvalid handle\n\n");
		return -1;
	}

	length.QuadPart = Length;
	offset.QuadPart = ByteOffset;

	if (UnlockFile(handle, offset.HighPart, offset.LowPart, length.HighPart, length.LowPart)) {
		fprintf(stderr, "\tsuccess\n\n");
		return 0;
	} else {
		fprintf(stderr, "\tfail\n\n");
		return -1;
	}*/
   return 0;
}


static int __stdcall MetaFSUnmount(PDOKAN_FILE_INFO DokanFileInfo) {
	fprintf(stderr, "Unmount\n");
	return 0;
}


static DOKAN_OPERATIONS
dokanOperations = {
	MetaFSCreateFile,
	MetaFSOpenDirectory,
	MetaFSCreateDirectory,
	MetaFSCleanup,
	MetaFSCloseFile,
	MetaFSReadFile,
	MetaFSWriteFile,
	MetaFSFlushFileBuffers,
	MetaFSGetFileInformation,
	MetaFSFindFiles,
	NULL, // FindFilesWithPattern
	MetaFSSetFileAttributes,
	MetaFSSetFileTime,
	MetaFSDeleteFile,
	MetaFSDeleteDirectory,
	MetaFSMoveFile,
	MetaFSSetEndOfFile,
	MetaFSLockFile,
	MetaFSUnlockFile,
	NULL, // GetDiskFreeSpace
	NULL, // GetVolumeInformation
	MetaFSUnmount // Unmount
};

int __cdecl main(ULONG argc, PCHAR argv[]) {
   printf("test");
   
   PDOKAN_OPTIONS dokanOptions = (PDOKAN_OPTIONS)malloc(sizeof(DOKAN_OPTIONS));

	DatabaseWrapper wrapper;

	if (argc < 3) {
		fprintf(stderr, "dokan.exe RootDirectory DriveLetter [ThreadCount]\n");
		return -1;
	}

	ZeroMemory(dokanOptions, sizeof(DOKAN_OPTIONS));

	mbstowcs(RootDirectory, argv[1], strlen(argv[1]));
	wprintf(L"RootDirectory: %ls\n", RootDirectory);

	dokanOptions->DriveLetter = argv[2][0];

	if (argc == 4)
		dokanOptions->ThreadCount = atoi(argv[3]);
	else
		dokanOptions->ThreadCount = 1;
	dokanOptions->DebugMode = 1;

	DokanMain(dokanOptions, &dokanOperations);

	return 0;
}

