
#pragma once

#include <string>
#include <map>

struct sqlite3_stmt;
class TagDirectoryLister {
public:
   TagDirectoryLister(std::string startDir);
   ~TagDirectoryLister();

   std::string getFirstTagInCurDirectory();
   std::string getNextTagInCurDirectory();

   std::string getNextFile();
protected:
   void addTagToAlltagsInCurDirectory(std::string allTags);

   std::map<std::string, std::string> mTagsInDirectoryPath;

   std::map<std::string, std::string> mTags;
   std::map<std::string, std::string>::iterator mTagIterator;

   sqlite3_stmt *query;
};
